﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Serialization;
using System.Threading;

namespace ClientServerTalk
{
    class Server : MarshalByRefObject//, IRemotingTypeInfo  I
    {
        List<Client> m_clients = new List<Client>();
        int count = 0;

        public Server() { }
        public int AddClient(Client client) { m_clients.Add(client); return ++count; } // client.m_no = count; }
        public void RemoveClient(Client client) { m_clients.Remove(client); }
        public void Talk(int client_no, string s)
        {
            List<int> to_remove = new List<int>();
            int b = 0;
            foreach (Client c in m_clients)
            {
                try
                {
                    c.Talk(client_no, s);
                }
                catch
                {
                    to_remove.Add (b);
                }
                ++b;
            }
            b = 0;
            foreach (int c in to_remove)
                m_clients.RemoveAt(c-b++);

        }
    }
    class Client : MarshalByRefObject
    {
        public int m_no;
        public void Talk(int client_no, string s) { if (client_no != m_no) Console.WriteLine("{0} kaze : {1}", client_no, s); }
    }

    class Program
    {
        static void ServerMain()
        {
            RemotingConfiguration.RegisterWellKnownServiceType(typeof(Server), "ClientServerTalk.Server", WellKnownObjectMode.Singleton);
            Console.WriteLine("Server started (Singleton)");
            Console.ReadLine();
        }
        static void ClientMain()
        {
            Server server = (Server)Activator.GetObject(typeof(Server), @"tcp://localhost:12345/ClientServerTalk.Server");
            if (server == null)
            {
                System.Console.WriteLine("Could not locate server");
                return;
            }
            Client client = new Client();
            client.m_no = server.AddClient(client);
            string s;
            do
            {
                s = Console.ReadLine();
                server.Talk(client.m_no, s);
            } while (s != "");
            server.RemoveClient(client);
        }
        static void Main(string[] args)
        {
            bool server = true;
            TcpChannel chan;
            BinaryServerFormatterSinkProvider provider = new BinaryServerFormatterSinkProvider();
            provider.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;
            IDictionary props = new Hashtable();
            props["port"] = 12345;
            try
            {
                chan = new TcpChannel(props, null, provider);
            }
            catch
            {
                props["port"] = 0;
                chan = new TcpChannel(props, null, provider);
                server = false;
            }
            ChannelServices.RegisterChannel(chan);
            if (server) ServerMain(); else ClientMain();
        }
    }
}
