﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Serialization;
using System.Threading;

namespace ClientServerEvent
{
    class Server : MarshalByRefObject
    {
        Client m_client;
        EventWaitHandle i_event;

        public Server() {}
        public void SetClient(Client client) { m_client = client; }
        public void SetEvent(EventWaitHandle ev) { i_event = ev; }
        public void Talk(string s)
        {
            if (m_client != null)
            {
                m_client.Talk(s);
                Console.WriteLine("Otislo i na klijent: {0}", s);
            }
            else Console.WriteLine("Talk: {0}", s);
            if (i_event != null) i_event.Set();
        }
    }
    class Client : MarshalByRefObject
    {
        public string m_talk;
        EventWaitHandle i_event;
        public void Talk(string s) { m_talk = s; Console.WriteLine("Promjena: {0}", s); if (i_event!=null) i_event.Set(); }
        public void SetEvent(EventWaitHandle ev) { i_event = ev; }
    }
    class ClientThread
    {
        public AutoResetEvent a = new AutoResetEvent(false);
        public Client m_c;
        public void DoThread()
        {
            while (true)
            {
                if (m_c != null) Console.WriteLine("Thread signaliziran {0}", m_c.m_talk); else Console.WriteLine("Thread signaliziran");
                a.WaitOne(5000);
            }
        }
    }
    class Program
    {
        static void ServerMain()
        {
            RemotingConfiguration.RegisterWellKnownServiceType(typeof(Server), "VinkoServer", WellKnownObjectMode.Singleton);
            Console.WriteLine("Server started (Singleton)");
            Console.ReadLine();
        }
        static void ClientMain()
        {
            Server server = (Server)Activator.GetObject(typeof(Server),@"tcp://localhost:12345/VinkoServer");
            if (server == null)
            {
                System.Console.WriteLine("Could not locate server");
                return;
            }
            ClientThread p = new ClientThread();
            Thread t = new Thread(new ThreadStart(p.DoThread)); t.Start();
            server.SetEvent(p.a);
            Client client = new Client();
            p.m_c = client;
            //client.SetEvent(p.a);
            server.SetClient(client);
            string s;
            do
            {
                s = Console.ReadLine();
                server.Talk(s);
//                p.a.Set();
            } while (s != "");
            t.Abort();
        }
        static void Main(string[] args)
        {
            bool server = true;
            TcpChannel chan;
            BinaryServerFormatterSinkProvider provider = new BinaryServerFormatterSinkProvider();
            provider.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;
            IDictionary props = new Hashtable();
            props["port"] = 12345;
            try {
                chan = new TcpChannel(props, null, provider);
            }
            catch {
                props["port"] = 0;
                chan = new TcpChannel(props, null, provider);
                server = false;
            }
            ChannelServices.RegisterChannel(chan);
            if (server) ServerMain(); else ClientMain();

        }
    }
}
